﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports Checkbox_Test.Produktklasse
Imports System.Runtime.CompilerServices
Imports Checkbox_Test.Eingabe



Public Class MainViewModel
    Implements INotifyPropertyChanged
    Public Sub New()
        With Checkboxliste
            .Add(New Produktlisteneintrag(New Standardbauteil("Prod1", "Pictures/Prod1.png")))
            .Add(New Produktlisteneintrag(New Bauteil_1("Prod2", "Pictures/Prod2.png", "Button Bauteil 1 Prod 2")))
            .Add(New Produktlisteneintrag(New Bauteil_1("Prod3", "Pictures/Prod3.png", "Button Bauteil 1 Prod 3")))
            .Add(New Produktlisteneintrag(New Bauteil_2("Prod4", "Pictures/Prod4.png", "Button Bauteil 2 Prod 4")))
            .Add(New Produktlisteneintrag(New Bauteil_2("Prod5", "Pictures/Prod5.png", "Button Bauteil 2 Prod 5")))
            .Add(New Produktlisteneintrag(New Standardbauteil("Prod6", "Pictures/Prod6.png")))
            .Add(New Produktlisteneintrag(New Standardbauteil("Prod7", "Pictures/Prod7.png")))
            .Add(New Produktlisteneintrag(New Bauteil_1("Prod8", "Pictures/Prod8.png", "Button Bauteil 1 Prod 8")))
            .Add(New Produktlisteneintrag(New Bauteil_1("Prod9", "Pictures/Prod9.png", "Button Bauteil 1 Prod 9")))
            .Add(New Produktlisteneintrag(New Bauteil_2("Prod10", "Pictures/Prod10.png", "Button Bauteil 2 Prod 10")))
            .Add(New Produktlisteneintrag(New Bauteil_2("Eagle", "Pictures/Eagle.png", "Button Bauteil 2 Eagle")))
            .Add(New Produktlisteneintrag(New Bauteil_1("Dog", "Pictures/Dog.png", "Button Bauteil 1 Dog")))
            .Add(New Produktlisteneintrag(New Bauteil_2("Cat", "Pictures/Cat.png", "Button Bauteil 2 Cat")))
            .Add(New Produktlisteneintrag(New Standardbauteil("Spider", "Pictures/Spider.png")))
        End With

        With Eingabeliste
            .Add(New Eingaben_MainView("A", ""))
            .Add(New Eingaben_MainView("B", ""))
            .Add(New Eingaben_MainView("C", ""))
            .Add(New Eingaben_MainView("D", ""))
            .Add(New Eingaben_MainView("E", ""))
        End With

        For Each eintrag As Produktlisteneintrag In Checkboxliste
            AddHandler eintrag.EintragCheckedChanged, AddressOf EintragCheckedChanged
        Next

        Klick = New RelayCommand(AddressOf Klick_Execute, AddressOf KlickCanExecute)
        Back = New RelayCommand(AddressOf Klick_Execute_Back, AddressOf KlickCanExecute)
        Forward = New RelayCommand(AddressOf Klick_Execute_Forward, AddressOf KlickCanExecute)

    End Sub


    Public Property Checkboxliste As ObservableCollection(Of Produktlisteneintrag) = New ObservableCollection(Of Produktlisteneintrag)
    Public Property Produktliste As ObservableCollection(Of Bauteil) = New ObservableCollection(Of Bauteil)
    Public Property Eingabeliste As ObservableCollection(Of Eingaben_MainView) = New ObservableCollection(Of Eingaben_MainView)

    Private _SelectedProdukt As Bauteil
    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

    Protected Overridable Sub RaisePropertyChanged(<CallerMemberName> Optional ByVal prop As String = "")
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(prop))
    End Sub

    Public Property SelectedProdukt As Bauteil
        Get
            SelectedProdukt = _SelectedProdukt
        End Get
        Set(value As Bauteil)
            _SelectedProdukt = value
            RaisePropertyChanged()
        End Set
    End Property
    Public Property Klick As ICommand
    Public Property Back As ICommand
    Public Property Forward As ICommand

    Private Sub Klick_Execute(obj As Object)
        SelectedProdukt = DirectCast(obj, Bauteil)
    End Sub
    Private Function KlickCanExecute(obj As Object) As Boolean
        'Return true wenn der Command ausgeführt werden darf oder false wenn nicht
        Return obj IsNot Nothing AndAlso TryCast(obj, Bauteil) IsNot Nothing
    End Function

    Public ProduktMove As String

    Private Sub Klick_Execute_Back(obj As Object)
        Dim Direction As String = "Backward"
        ProduktMove = DirectCast(obj, Bauteil).Produktname
        MoveBauteil(ProduktMove, Direction)
    End Sub

    Private Sub Klick_Execute_Forward(obj As Object)
        Dim Direction As String = "Forward"
        ProduktMove = DirectCast(obj, Bauteil).Produktname
        MoveBauteil(ProduktMove, Direction)
    End Sub


    Private Sub EintragCheckedChanged(Haken As Boolean, neuesBild As Bauteil)
        If Haken Then
            Produktliste.Add(neuesBild)
        Else
            Produktliste.Remove(neuesBild)
        End If

    End Sub

    Sub MoveBauteil(aktProdukt As String, MoveDirection As String)

        Dim pos As Integer = 0

        For i = 0 To Produktliste.Count - 1
            If Produktliste.Item(i).ToString = aktProdukt Then
                If MoveDirection = "Backward" Then
                    If i - 1 < 0 Then
                        MessageBox.Show("Verschieben nicht möglich!")
                        Exit Sub
                    End If
                    Produktliste.Move(i, i - 1)
                    Exit Sub
                Else
                    If i + 1 = Produktliste.Count Then
                        MessageBox.Show("Verschieben nicht möglich!")
                        Exit Sub
                    End If
                    Produktliste.Move(i, i + 1)
                    Exit Sub
                End If
            End If
        Next
    End Sub


End Class
